<?php 

function pan_get_tables_db() 
{
	global $forum_db;
	
	$query = 'SHOW TABLES';
	$tables = $forum_db->query($query);
	
	$arr_tables = array();
	while($tmp_tab = $forum_db->fetch_row($tables))
	{
		$arr_tables[] = $tmp_tab[0];
	}

	return $arr_tables;
}

function pan_get_fields_table($table) 
{
	global $forum_db, $db_prefix;
	
	$query = 'SHOW COLUMNS FROM '.$db_prefix . $table ;
	$fields = $forum_db->query($query);
	
	$array_fields = array();
	while($tmp_fields = $forum_db->fetch_row($fields))
	{
		$array_fields[] = $tmp_fields[0];
	}
	
	return $array_fields;
}

//
function pan_array_to_string($values, $table_name, $first_field)
{
	global $forum_db;

	$output = array();
	foreach ( $values as $key => $input ) 
	{
		if ( $input != '' )
			$value = '\''.$forum_db->escape($input).'\'';
		else 
			$value = 'NULL';
		
		if ($forum_db->field_exists($table_name, $key) && $first_field != $key )
			$output[] = $key.'='. $value;
	}
	return $output;
}

//
function pan_create_dump_table_php($table_name, $dump_path)
{
	global $forum_db, $forum_url;
	
	$query = array(
		'SELECT'	=> '*',
		'FROM'		=> $table_name,
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$output = array();
	while ($rows = $forum_db->fetch_assoc($result))
		$output[] = $rows;
	
	if (!function_exists('write_cache_file'))
		require FORUM_ROOT.'include/cache.php';
	
	$file_name = $table_name.'_'.date('Ymd_His');
	
	// Output config as PHP code
	if (!write_cache_file($dump_path.$file_name.'.php', '<?php if (!defined(\'FORUM\')) die();'."\n\n".'$table_name = \''.$table_name."';\n\n".'$'.$table_name.' = '.var_export($output, true).';'."\n\n".'?>'))
	{
		error('Unable to write configuration cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
	}
	
}

//TESTED
function pan_create_dump_db()
{
	global $forum_db, $db_host, $db_username, $db_password, $db_name, $forum_url, $forum_config;

		$dump_dir = FORUM_ROOT.$forum_url['pan_backup_db_dump'];
		$tables = '*';

		$link_sql = @mysql_connect($db_host, $db_username, $db_password);
		@mysql_select_db($db_name, $link_sql);

		//get all of the tables
		if($tables == '*') {
			$tables = array();
			$result = @mysql_query('SHOW TABLES');
			while($row = @mysql_fetch_row($result)) {
				$tables[] = $row[0];
			}

		} else {
			$tables = is_array($tables) ? $tables : explode(',' ,$tables);
		}

		$return_sql = '';
		//cycle through
		foreach($tables as $table) {
			$result = @mysql_query('SELECT * FROM '.$table);
			$num_fields = @mysql_num_fields($result);

			$return_sql.= 'DROP TABLE IF EXISTS `'.$table.'`;';
			$row2 = @mysql_fetch_row(@mysql_query('SHOW CREATE TABLE '.$table));
			$return_sql.= "\n\n".$row2[1].";\n\n";

			for ($i = 0; $i < $num_fields; $i++) {
				while($row = @mysql_fetch_row($result)) {
					$return_sql.= 'INSERT INTO '.$table.' VALUES(';
					for($j=0; $j < $num_fields; $j++) {
						$row[$j] = addslashes($row[$j]);
//						$row[$j] = ereg_replace("\n","\\n",$row[$j]);
						$row[$j] = preg_replace("/\n/", "\\n" ,$row[$j]);

						if (isset($row[$j])) { 
							$return_sql.= '"'.$row[$j].'"' ; } else { $return_sql.= '""'; }
						if ($j < ($num_fields-1)) {
							$return_sql.= ','; }
					}
					$return_sql.= ");\n";
				}
			}
			$return_sql.="\n\n\n";
		}

		//save file
		$new_name_db = '.'.date("ymdHis").'_'.md5(time());
		$handle = fopen($dump_dir . $new_name_db.'.sql','w+');
		fwrite($handle, $return_sql);
		fclose($handle);

	if(file_exists($dump_dir . $new_name_db.'.sql')) {
		//Update Options
		$query = array(
			'UPDATE'	=> 'config',
			'SET'		=> 'conf_value='.time(),
			'WHERE'		=> 'conf_name=\'o_pan_backup_db_last\''
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);

		// Regenerate the config cache
		if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
			@require FORUM_ROOT.'include/cache.php';
		@generate_config_cache();

		// If changed sef - remove quick-jump cache
		if (!empty($forum_config['o_sef']) && !empty($form['sef'])) {
			if ($forum_config['o_sef'] != $form['sef']) {
				clean_quickjump_cache();
			}
		}
	}

	//Validate Num BackUp Copies
	$dir_sql = opendir($dump_dir);
	$count_sql = 0;
	$sql_array = array();
	while (false !== ($sql_file = readdir($dir_sql))) {
		if (strpos($sql_file, '.sql')) {
			$sql_array[filemtime($dump_dir . $sql_file)] = $sql_file;
			ksort($sql_array);
			$count_sql++;
		}
	}
//	closedir($dump_dir);

	if($count_sql > $forum_config['o_pan_backup_db_num']) {
		foreach($sql_array as $key => $value) {
			$last_sql = $sql_array[$key];
			break;
		} 
		@unlink($dump_dir . $last_sql);
	}

}
