<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');
require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';


if (isset($_POST['save_config']))
{
	//Update Options
	$form = array_map('trim', $_POST['form']);
	foreach ($form as $key => $input)
	{
		// Only update option values that have changed
		if (array_key_exists('o_'.$key, $forum_config) && $forum_config['o_'.$key] != $input)
		{
			if ($input != '' || is_int($input))
				$value = '\''.$forum_db->escape($input).'\'';
			else
				$value = 'NULL';

			$query = array(
				'UPDATE'	=> 'config',
				'SET'		=> 'conf_value='.$value,
				'WHERE'		=> 'conf_name=\'o_'.$forum_db->escape($key).'\''
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			
			// Regenerate the config cache
			if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
				require FORUM_ROOT.'include/cache.php';

			generate_config_cache();

			// If changed sef - remove quick-jump cache
			if (!empty($forum_config['o_sef']) && !empty($form['sef']))
			{
				if ($forum_config['o_sef'] != $form['sef'])
				{
					clean_quickjump_cache();
				}
			}
		}
	}
	$forum_flash->add_info('Settings updated.');
	redirect(forum_link($forum_url['pan_backup_db_settings']), '');
}

$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		'Backup_DB'
);
	
define('FORUM_PAGE_SECTION', 'pan-backup-db');
define('FORUM_PAGE', 'admin-pan-backup-db-settings');
require FORUM_ROOT.'header.php';
	
// START SUBST - <!-- forum_main -->
ob_start();

?>
	<div class="main-subhead">
		<h2 class="hn"><span>Create DB</span></h2>
	</div>
	
	<div class="main-content main-frm">
		
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_backup_db_settings']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_backup_db_settings'])) ?>" />>
			</div>
			
			<div class="sf-set set">
				<div class="sf-box checkbox">
					<input type="hidden" name="form[pan_backup_db]" value="0" />
					<span class="fld-input"><input type="checkbox" id="fld<?php   ?>" name="form[pan_backup_db]" value="1"<?php if ($forum_config['o_pan_backup_db'] == '1') echo 'checked="checked"' ?> /></span>
					<label for="fld "><span>Auto_Back_Up</span>Auto_Back_Up_Info</label>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Interval</span><small>Set_Interval</small></label><br />
					<span class="fld-input"><input type="number" id="fld" name="form[pan_backup_db_day]" size="10" maxlength="7" value="<?php echo forum_htmlencode($forum_config['o_pan_backup_db_day']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Number_copies</span><small>Number_copies</small></label><br />
					<span class="fld-input"><input type="number" id="fld" name="form[pan_backup_db_num]" size="10" maxlength="7" value="<?php echo forum_htmlencode($forum_config['o_pan_backup_db_num']) ?>" /></span>
				</div>
			</div>

            <div class="sf-set set">
                <div class="sf-box checkbox">
                    <span class="fld-input"><input type="checkbox" id="fld" name="form[pan_backup_db_last]" value="<?php echo time() ?>" /></span>
                    <label for="fld "><span>Create_Now</span>Create_Now_Info</label>
                </div>
            </div>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="save_config" value="Update_Config" /></span>
			</div>
		</form>

	</div>
			
<?php
$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';

