<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');
	
require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

if (isset($_POST['save_table']))
{
	$table_name = $_POST['table_name'];
	$dumps_path = FORUM_ROOT.$forum_url['pan_backup_db_dump_tables'];
	
	pan_create_dump_table_php($table_name, $dumps_path);
	
	$forum_flash->add_info('Dump table '.$table_name.' created.');
	redirect(forum_link($forum_url['pan_backup_db_tables']), '');
}

if (isset($_POST['restore_table']))
{
	$file_path = $_POST['file_path'];
	if (file_exists($file_path))
		include $file_path;
	
	if (isset($table_name))
	{
		//DELETE ALL FIELDS
		$query = array(
			'DELETE'	=> $table_name,
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$str_count = 0;
		foreach (${$table_name} as $key => $string)
		{
			//FUNCTION
			$val_count = 1;
			foreach ($string as $col => $value)
			{
				if ($value != '')
				{
					if ($val_count == 1) {
						$col_as_str = $col;
						$val_as_str = "'".$forum_db->escape($value)."'";
					} else {
						$col_as_str .= ', '.$col;
						$val_as_str .= ', '."'".$forum_db->escape($value)."'";
					}
				}
				
				$val_count++;
			}
			
			//ADD NEW DATA
			$query = array(
				'INSERT'	=> $col_as_str,
				'INTO'		=> $table_name,
				'VALUES'	=> $val_as_str,
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			
			$str_count++;
		}
	}
	
	$forum_flash->add_info('File restored '.$str_count);
	redirect(forum_link($forum_url['pan_backup_db_tables']), '');
}

if (isset($_POST['delete_table']))
{
	$file_path = $_POST['file_path'];
	if (file_exists($file_path))
		unlink($file_path);
	
	$forum_flash->add_info('Dump file deleted.');
	redirect(forum_link($forum_url['pan_backup_db_tables']), '');
}

$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		'Backup_Tables'
);

define('FORUM_PAGE_SECTION', 'pan-backup-db');
define('FORUM_PAGE', 'admin-pan-backup-db-tables');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>
	<div class="main-subhead">
		<h2 class="hn"><span>BackUp Tables</span></h2>
	</div>
	
	<div class="main-content main-frm">

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_backup_db_tables']) ?>">
			
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_backup_db_tables'])) ?>" />
			</div>
			
			<div class="sf-set set">
				<div class="sf-box select">
					<label for="fld">
						<span>Available Tables</span>
							</label><br />
								<span class="fld-input"><select name="table_name">
<?php

$tables = pan_get_tables_db();
foreach ($tables as $table)
{
	$table = str_replace($db_prefix, '', $table);
	echo "\t\t\t\t\t\t\t\t".'<option value="'.$table.'">'.$table.'</option>'."\n";
}
?>
					</select></span>
				</div>
			</div>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="save_table" value="Create Dump" /></span>
			</div>
		</form>


		<div class="ct-group">
			
			<table>
				<thead>
					<tr>
						<th class="tc0" style="width:20%;">DB_Created</th>
						<th class="tc1" style="width:15%;">DB_Size</th>
						<th class="tc2" style="width:35%;">DB_Name</th>
						<th class="tc3" style="width:10%;">DB_Restore</th>
						<th class="tc4" style="width:10%;">DB_Delete</th>
						
					</tr>
				</thead>
			<tbody>
				
<?php 
	foreach (scandir(FORUM_ROOT.$forum_url['pan_backup_db_dump_tables']) as $files_sql) {
		if (strpos($files_sql, '.php')) {
			$file_part = $files_sql;
?>
		<form action="<?php echo forum_link($forum_url['pan_backup_db_tables']) ?>" accept-charset="utf-8" method="post" class="frm-form">
				<tr>
					<input type="hidden" value="<?php echo generate_form_token(forum_link($forum_url['pan_backup_db_tables'])) ?>" name="csrf_token" />
					<input type="hidden" name="file_path" value="<?php echo FORUM_ROOT.$forum_url['pan_backup_db_dump_tables'] . $file_part ?>" />
					
					<td class="tc0"><strong><?php echo  date("d F Y H:i:s", filectime(FORUM_ROOT.$forum_url['pan_backup_db_dump_tables'] . $file_part)); ?></strong></td>
					<td class="tc1"><?php echo  round( filesize (FORUM_ROOT.$forum_url['pan_backup_db_dump_tables'].$file_part)/1024, 1).' kB'; ?></td>
					<td class="tc2"><?php echo $file_part ?></td>
					
					<td class="tc3"><input type="submit" name="restore_table" value="Restore" /></td>
					<td class="tc4"><input type="submit" name="delete_table" value="Delete" /></td>
				</tr>
		</form>
<?php
		}
	}
?>
				</tbody>
			</table>
			
		</div>

	</div>

<?php
$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';

